<template>
  <div
    class="w-full flex flex-col"
    :class="size === ComponentSizes.default ? 'w-[994px] gap-4' : 'w-full min-w-[320px] max-w-[640px] gap-5'"
  >
    <div
      class="w-full self-stretch"
      :class="size === ComponentSizes.default ? 'flex items-start gap-6' : 'flex flex-col items-center gap-4'"
    >
      <!-- Edit avatar -->
      <div
        class="relative"
        :class="size === ComponentSizes.default ? 'flex flex-col gap-1 items-center' : ''"
      >
        <svn-pro-avatar
          :type="avatar ? 'photo' : 'monogram'"
          :image="avatar"
          :firstname="firstname"
        />

        <svn-pro-icon-button
          v-if="size !== ComponentSizes.default && pictureEditable"
          icon="custom:mingcute:camera-2-line"
          color="surface"
          variant="elevated"
          class="absolute -right-[19px] -bottom-1"
          @click="onUpload"
        />

        <svn-pro-button
          v-else-if="size === ComponentSizes.default && pictureEditable"
          text="Edit photo"
          variant="text"
          prepend-icon="custom:mingcute:camera-2-line"
          @click="onUpload"
        />
      </div>

      <!-- Settings button -->
      <slot v-if="size == ComponentSizes.compact && showSettings" name="settings">
        <svn-pro-button
          text="Settings"
          variant="outlined"
          prepend-icon="custom:mingcute:settings-3-line"
        />
      </slot>

      <div
        class="w-full flex flex-col gap-5 self-stretch"
        :class="size === ComponentSizes.default ? 'w-full items-start' : 'items-center'"
      >
        <!-- Firstname + Lastname -->
        <div
          class="flex justify-between"
          :class="size === ComponentSizes.default ? 'w-full items-start' : 'items-center'"
        >
          <div
            class="flex flex-col"
            :class="size === ComponentSizes.default ? 'items-start' : 'items-center'"
          >
            <svn-pro-title h6 medium color="onSurface">
              {{ firstname }} {{ lastname }}
            </svn-pro-title>
  
            <svn-pro-text mediumLarge regular color="onSurfaceVariant">
              {{ email }}
            </svn-pro-text>
          </div>

          <!-- Settings button -->
          <slot v-if="size === ComponentSizes.default && showSettings" name="settings">
            <svn-pro-button
              text="Settings"
              variant="outlined"
              prepend-icon="custom:mingcute:settings-3-line"
            />
          </slot>
        </div>

        <!-- Tags -->
        <div
          class="flex content-start flex-wrap"
          :class="size === ComponentSizes.default ? 'max-w-[640px] gap-3' : 'max-w-[360px] justify-center items-center gap-2'"
        >
          <svn-pro-info-tag
            v-for="(tag, index) in tags"
            :key="index"
            :text="tag"
            tag-type="info"
            :tag-size="size"
            tag-style="filled"
          />
        </div>

        <!-- Badges -->
        <div
          v-if="showBadges"
          class="flex gap-2 self-stretch items-center"
          :class="size === ComponentSizes.default ? '' : 'justify-center'"
        >
          <svn-pro-text mediumLarge medium color="onSurfaceVariant">
            {{ "Learn Badges:" }}
          </svn-pro-text>

          <div class="flex items-center gap-2 cursor-pointer">
            <svn-pro-tooltip
              v-for="(badgeType, index) in badgeTypes"
              :key="index"
              :max-width="undefined"
              :text="getTooltipText(badgeType)"
            >
              <template #activator="{ props }">
                <div v-bind="props" class="relative cursor-pointer" @click="badgesClicked">
                  <v-img
                    class="w-10 h-10"
                    cover
                    :src="getBase(badgeType)"
                  />

                  <v-img
                    cover
                    :src="getIcon(badgeType)"
                    class="absolute top-1/2 left-1/2 -translate-x-1/2 -translate-y-1/2 w-4 h-4"
                  />
                </div>
              </template>
            </svn-pro-tooltip>
          </div>
        </div>
      </div>
    </div>

    <svn-pro-divider color="borderColor"/>

    <v-file-input
      ref="picker"
      type="file"
      accept="image/*"
      class="hidden"
      @change="uploadFile"
    />
  </div>
</template>

<script setup>
import { ref } from 'vue';
import SvnProText from '../styles/SvnProText.vue';
import SvnProTitle from '../styles/SvnProTitle.vue';
import SvnProInfoTag from '../chip/SvnProInfoTag.vue';
import SvnProButton from '../button/SvnProButton.vue';
import SvnProAvatar from '../avatar/SvnProAvatar.vue';
import SvnProDivider from '../divider/SvnProDivider.vue';
import SvnProIconButton from '../button/SvnProIconButton.vue';
import BaseCompleted from '../../assets/base_completed.svg';
import BaseOngoing from '../../assets/base_ongoing.svg';
import HeartCompleted from '../../assets/heart_completed.svg';
import HeartOngoing from '../../assets/heart_ongoing.svg';
import OpenBookCompleted from '../../assets/open_book_completed.svg';
import OpenBookOngoing from '../../assets/open_book_ongoing.svg';
import PuzzleCompleted from '../../assets/puzzle_completed.svg';
import PuzzleOngoing from '../../assets/puzzle_ongoing.svg';
import ThumbCompleted from '../../assets/thumb_completed.svg';
import ThumbOngoing from '../../assets/thumb_ongoing.svg';
import SvnProTooltip from '../tooltip/SvnProTooltip.vue';
import { ComponentSizes } from '../../constants/types';

const props = defineProps({
  size: {
    type: String,
    default: ComponentSizes.default,
  },
  avatar: {
    type: String,
    default: undefined,
  },
  firstname: {
    type: String,
    default: "John",
  },
  lastname: {
    type: String,
    default: "Doe",
  },
  email: {
    type: String,
    default: "johndoe@bigmammagroup.com",
  },
  tags: {
    type: Array,
    default: () => [],
  },
  showBadges: {
    type: Boolean,
    default: true,
  },
  pictureEditable: {
    type: Boolean,
    default: true,
  },
  badgeTypes: {
    type: Array,
    default: () => [],
  },
  showSettings: {
    type: Boolean,
    default: () => true,
  }
})

const emit = defineEmits(['edit-picture', 'image-selected', 'open-badges-modal'])

const picker = ref(null);

const getBase = (badgeType) => {
  if (badgeType?.count) {
    return BaseCompleted
  } else {
    return BaseOngoing
  }
}

const getIcon = (badgeType) => {
  if (badgeType?.name === "trainings") {
    if (badgeType?.count) {
      return OpenBookCompleted
    } else {
      return OpenBookOngoing
    }
  } else if (badgeType?.name === "modules") {
    if (badgeType?.count) {
      return PuzzleCompleted
    } else {
      return PuzzleOngoing
    }
  } else if (badgeType?.name === "likes") {
    if (badgeType?.count) {
      return HeartCompleted
    } else {
      return HeartOngoing
    }
  } else if (badgeType?.name === "reactions") {
    if (badgeType?.count) {
      return ThumbCompleted
    } else {
      return ThumbOngoing
    }
  }
}

const getTooltipText = (badgeType) => {
  switch (badgeType?.name) {
    case 'modules':
      if (badgeType?.count < 5) {
        return "Enlightened Novice"
      } else if (badgeType?.count >= 5 && badgeType?.count < 10) {
        return "Knowledge Explorer"
      } else if (badgeType?.count >= 10 && badgeType?.count < 25) {
        return "Thirsty for Knowledge"
      } else if (badgeType?.count >= 25) {
        return "Curriculum Master"
      }
    case 'reactions':
      if (badgeType?.count < 5) {
        return "The Approver"
      } else if (badgeType?.count >= 5 && badgeType?.count < 10) {
        return "Positive Supporter"
      } else if (badgeType?.count >= 10 && badgeType?.count < 25) {
        return "Enlightened Evaluator"
      } else if (badgeType?.count >= 25) {
        return "Master of Emotions"
      }
    case 'trainings':
      if (badgeType?.count < 5) {
        return "Accomplished Apprentice"
      } else if (badgeType?.count >= 5 && badgeType?.count < 10) {
        return "Trained and Competent"
      } else if (badgeType?.count >= 10 && badgeType?.count < 25) {
        return "Certified Expert"
      } else if (badgeType?.count >= 25) {
        return "Training Champion"
      }
    case 'likes':
      if (badgeType?.count < 5) {
        return "The Selector"
      } else if (badgeType?.count >= 5 && badgeType?.count < 10) {
        return "Content Lover"
      } else if (badgeType?.count >= 10 && badgeType?.count < 25) {
        return "Informed Collector"
      } else if (badgeType?.count >= 25) {
        return "Resource Guardian"
      }
  }
}

const onUpload = () => {
  // picker.value.click();
  emit('edit-picture')
}

const badgesClicked = () => {
  emit('open-badges-modal')
}

const uploadFile = async () => {
  emit('image-selected', picker?.value?.files[0])
};
</script>